from collections import Counter

OPS = {
    "+": lambda x, y: x + y,
    "-": lambda x, y: x - y if x >= y else None,
    "*": lambda x, y: x * y,
    "/": lambda x, y: x // y if y and not x % y else None,
}

def results(digits, ops):
    for digit in digits:
        yield digit, digits - Counter({digit: 1}), ops
    for op in ops:
        for r1, digits1, ops1 in results(digits, ops - Counter({op: 1})):
            for r2, digits2, ops2 in results(digits1, ops1):
                final = OPS[op](r1, r2)
                if final is not None:
                    yield final, digits2, ops2

def entry(target, bag):
    digits = Counter()
    i = 0
    while i < len(bag) and bag[i].isdigit():
        digits[int(bag[i])] += 1
        i += 1
    ops = Counter(bag[i:])
    return min(results(digits, ops), key=lambda r: abs(r[0] - target))[0]
